/** 
As a person of little brain, I find it difficult to use hex editors 
for reading chars, when I am thinking in terms of decimal ascii.

Here's a (real stupid) program that lets me type in values from and
to, which it then displays in char and dec format.

etonkin@[NOSPAM,I'MBRITISH]]free.fr

may 2002

*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int file_length(FILE *input_file)
{
  int i,j,tmpint;
  rewind(input_file);
  i=ftell(input_file);
  fseek(input_file,0,SEEK_END);
  j=ftell(input_file);
  rewind(input_file);
  tmpint=j-i;
  return tmpint;

}

void print_bytes(FILE *input_file,int start,int finish)
{
  int tmpint,count;
  char tmpchar;
  fseek(input_file,0,start);
  tmpint=finish-start;
  for(count=0;count<tmpint;count++){
    if(count%10==0){
      printf("\n %i : ",start+count);
      }
    tmpchar=getc(input_file);
    printf("%i[",tmpchar);
    if(tmpchar>30 && tmpchar<127){
      printf("%c",tmpchar);
    } else {
      printf(" ");
    }
    printf("] ");
  }
  printf("\n");
}


int main(int argc, char* argv[])
{
   
  FILE *input_file;
  char tmpchar;
  int start,finish,filesize;

  if (argc != 2) {
    
    printf("\nSyntax is:");
    printf("\n\tBin2dec\n\t\tinput filename");		
    printf("\n\t\toutput_name\n");		
    
    return -1;
  }	

  if((input_file=fopen(argv[1],"r"))==NULL){
    
    fprintf(stderr,"Cannot open %s\n",argv[1]);
    return -1;
  }

  filesize=file_length(input_file);
 

  while(finish!=-1){
    printf("Starting point (-1 to quit, filesize %i bytes)\n",filesize);
    fflush(stdin);
    fscanf(stdin,"%i",&start);
    if(start<0){
      return 0;
    }
    fflush(stdin);
    printf("Finishing point (-1 to quit)\n");
    fscanf(stdin,"%i",&finish);
    /* 
       Check if the starting point is after the finishing point
    */
    if(start<0){
      return 0;
    }
    
    if(start<finish){
      if(finish>=filesize){
	finish=filesize;
      }
      printf("Dec(char) values for bytes %i to %i:\n",start,finish);
      print_bytes(input_file,start,finish);
      
    } else {
      printf("Start should be smaller than finishing point!\n");
    }
    
  }
  
 
  fclose(input_file);
  
  
  
}

