
/* 

Randomly nicked from a combination of other programs, including 
xanim, a web page, www.rasnaimaging.com/people/lapus/ 
and Mpeg4IP 
*/

typedef struct 
{
  long pos;
  long len;

}video_index_entry;

typedef struct
{
  long pos;
  long len;
  long tot;
}audio_index_entry;

struct avi_stream_type
{
  unsigned long stream_type;
  unsigned long handler;
  unsigned long flags;
  unsigned long reserved;
  unsigned long initial_frames;
  unsigned long scale;
  unsigned long rate;
  unsigned long start;
  unsigned long length;
  unsigned long suggested_buffer_size;
  unsigned long quality;
  unsigned long sample_size;
  unsigned long reserved2;
  unsigned long reserved3;
};

struct avi_filetype
{
  FILE *filename;
  char *fdes;
  int is_riff; /* Are first 4 chars 'RIFF'? */
  int has_avi_hdr; /* is 9th,10th,11th byte 'AVI'? */
  int has_hdrl; /* checks out the 13-16th byte (LIST) and 21-24th(hdrl)*/
  unsigned long int microsec_per_frame; /* Microseconds per frame */
  unsigned long int max_bytes_per_second; /* Hardly a popular value :-/ */
  unsigned long int flags; /* */
  unsigned long int total_frames; /* Total number of frames */
  unsigned long int streams; /* Streams in file (normally 1 or 2, 1 audio, 1 vid) */
  unsigned long int width; /* Width of movie */
  unsigned long int height; /* Height of movie */
  unsigned long int initial_frames; /* Initial frames */
  char compressor[8];
  long video_strn;
  long video_frames;
  char video_tag[4];
  long video_pos;
  long a_fmt;
  long a_chans;
  long a_rate;
  long a_bits;
  long audio_strn;
  long audio_bytes;
  long audio_chunks;
  char audio_tag[4];
  long audio_posc;
  long audio_posb;
  long pos;
  long n_idx;
  long max_idx;
  unsigned char (*idx)[16];
  video_index_entry * video_index;
  audio_index_entry * audio_index;
  long last_pos;
  long last_len;
  int must_use_index;
  long movi_start;

};
